	/*
		2010.12.19. @watt
		Fnydekorci v1.00
		RGB LED vezrlse PWM jellel.
		PWM freki 70Hz
		Fnytmenet felbontsa 240 lps.
		Optimalizlt fnyerssg szntmeneteknl.
		A OF-HPRGB-1SL RGB LED-re optimalizlva.
		Hi-Tech C 9.8-al kell fordtani!
	*/

	#include "htc.h"

	__CONFIG(WDTDIS & INTCLK & UNPROTECT & BORDIS & LVPDIS & MCLREN);

	//Vltozk deklarlsa
	volatile static unsigned char  PWM_Period_Counter; 
	volatile static unsigned char  PWM_1_DUTY, PWM_2_DUTY, PWM_3_DUTY;
	volatile static unsigned int   Utem_Counter, Effekt_Counter;	

	unsigned char Flag1;
	unsigned int  var;
	unsigned int  Tempo; 
	unsigned char Effekt_Mutato;
	unsigned char Port_Temp;

	//Makr
	#define bitset(var, bitno)    ((var) |= 1UL << (bitno))
	#define bitclr(var, bitno)    ((var) &= ~(1UL << (bitno)))

	//Bit hivatkozsok
	#define PWM1_100_Flag 0
	#define PWM2_100_Flag 1
	#define PWM3_100_Flag 2
	
	//Konstansok
	#define	_PWM100 240	//PWM felbonts

	#define _Eff1_tempo 700	

	#define _Eff2_tempo1 600
	#define _Eff2_tempo2 800
	#define _Eff2_tempo3 1000

void main (void )
{

	TRISA=0X00;
	TRISB=0X00;	//Minden lb kimenet
	
	//PWM	
	PWM_Period_Counter=0;
	PWM_1_DUTY=0; 
	PWM_2_DUTY=0; 
	PWM_3_DUTY=0; 

	//OUT
	PORTB=0;

	//Flags
	Flag1=1;
	
	//Effekt 
	Utem_Counter=1;
	Effekt_Mutato=1;		// Effekten belli llapot mutat
	Tempo=_Eff1_tempo;		// Els tem megadsa

	Effekt_Counter=0;		// Az Effektet vlasztja ki

	while(1)
	{
		Port_Temp=0;
		if (PWM_Period_Counter >= PWM_1_DUTY)
		{  	RB0=0; 
		} 	
		else
		{	RB0=1;
		}
		if (PWM_Period_Counter >= PWM_2_DUTY)
		{  	RB1=0;
		} 	
		else
		{	RB1=1;
		}
		if (PWM_Period_Counter >= PWM_3_DUTY)
		{  	RB2=0;
		} 	
		else
		{	RB2=1;
		}
		++PWM_Period_Counter;		
		if (_PWM100+1==PWM_Period_Counter) PWM_Period_Counter=0;	
		Utem_Counter++;

		if (Utem_Counter==Tempo)
		{	
			if (Effekt_Counter<2)
			{
				if ((Flag1 & (1 << PWM1_100_Flag)))
				{	PWM_1_DUTY++;
					if (PWM_3_DUTY>0) PWM_3_DUTY--;
					if (_PWM100==PWM_1_DUTY)
					{ 
						bitclr(Flag1, PWM1_100_Flag);
						bitset(Flag1, PWM2_100_Flag);
					}
				}
				if ((Flag1 & (1 << PWM2_100_Flag)))
				{	PWM_2_DUTY++;
					PWM_1_DUTY--;
					if (_PWM100==PWM_2_DUTY) 					
					{
						bitclr(Flag1, PWM2_100_Flag);
						bitset(Flag1, PWM3_100_Flag);
					}				
				}
				if ((Flag1 & (1 << PWM3_100_Flag)))
				{	PWM_3_DUTY++;
					PWM_2_DUTY--;
					if (_PWM100==PWM_3_DUTY) 					
					{
						bitclr(Flag1, PWM3_100_Flag);
						bitset(Flag1, PWM1_100_Flag);
						Effekt_Counter++;
						if (2==Effekt_Counter) Tempo=_Eff2_tempo1;
					}				
				}
			}

			if (2==Effekt_Counter )
			{	
				switch (Effekt_Mutato)	
				{
					case 1:	//R G B sorrend
						if ((Flag1 & (1 << PWM1_100_Flag)))
						{	if (PWM_1_DUTY<_PWM100) PWM_1_DUTY++;
							if (PWM_3_DUTY>0) PWM_3_DUTY--;
							if (_PWM100==PWM_1_DUTY)
							{ 
								bitclr(Flag1, PWM1_100_Flag);
								bitset(Flag1, PWM2_100_Flag);
								Tempo=_Eff2_tempo2;
							}
						}
						if ((Flag1 & (1 << PWM2_100_Flag)))
						{	PWM_2_DUTY++;
							PWM_1_DUTY--;
							if (_PWM100/2==PWM_2_DUTY) 					
							{
								bitclr(Flag1, PWM2_100_Flag);
								bitset(Flag1, PWM3_100_Flag);
								Tempo=_Eff2_tempo3;
							}				
						}
						if ((Flag1 & (1 << PWM3_100_Flag)))
						{	PWM_3_DUTY++;
							PWM_2_DUTY--;
							PWM_1_DUTY--;
							if (_PWM100/4==PWM_3_DUTY) 					
							{
								bitclr(Flag1, PWM3_100_Flag);
							}				
						}
						if (!(Flag1 & (1 << PWM1_100_Flag)) && !(Flag1 & (1 << PWM2_100_Flag)) && !(Flag1 & (1 << PWM3_100_Flag)))
						{	PWM_3_DUTY--;
							PWM_2_DUTY--;
							PWM_1_DUTY--;
							if (0==PWM_3_DUTY) 					
							{
								bitset(Flag1, PWM2_100_Flag);
								Tempo=_Eff2_tempo1;
								Effekt_Mutato++;
							//	goto _kilep;
							}				
						}
						break;
					case 2: //G B R sorrend
						if ((Flag1 & (1 << PWM2_100_Flag)))
						{	PWM_2_DUTY++;
							if (_PWM100==PWM_2_DUTY)
							{ 
								bitclr(Flag1, PWM2_100_Flag);
								bitset(Flag1, PWM3_100_Flag);
								Tempo=_Eff2_tempo2;
							}
						}
						if ((Flag1 & (1 << PWM3_100_Flag)))
						{	PWM_3_DUTY++;
							PWM_2_DUTY--;
							if (_PWM100/2==PWM_3_DUTY) 					
							{
								bitclr(Flag1, PWM3_100_Flag);
								bitset(Flag1, PWM1_100_Flag);
								Tempo=_Eff2_tempo3;
							}				
						}
						if ((Flag1 & (1 << PWM1_100_Flag)))
						{	PWM_1_DUTY++;
							PWM_2_DUTY--;
							PWM_3_DUTY--;
							if (_PWM100/4==PWM_1_DUTY) 					
							{
								bitclr(Flag1, PWM1_100_Flag);
							}				
						}
						if (!(Flag1 & (1 << PWM1_100_Flag)) && !(Flag1 & (1 << PWM2_100_Flag)) && !(Flag1 & (1 << PWM3_100_Flag)))
						{	PWM_3_DUTY--;
							PWM_2_DUTY--;
							PWM_1_DUTY--;
							if (0==PWM_1_DUTY) 					
							{
								bitset(Flag1, PWM1_100_Flag);
								Tempo=_Eff2_tempo1;
								Effekt_Mutato++;
							//	goto _kilep;
							}				
						}
						break;
					case 3:	//R B G			
						if ((Flag1 & (1 << PWM1_100_Flag)))
						{	PWM_1_DUTY++;
							if (_PWM100==PWM_1_DUTY)
							{ 
								bitclr(Flag1, PWM1_100_Flag);
								bitset(Flag1, PWM3_100_Flag);
								Tempo=_Eff2_tempo2;
							}
						}
						if ((Flag1 & (1 << PWM3_100_Flag)))
						{	PWM_3_DUTY++;
							PWM_1_DUTY--;
							if (_PWM100/2==PWM_3_DUTY) 					
							{
								bitclr(Flag1, PWM3_100_Flag);
								bitset(Flag1, PWM2_100_Flag);
								Tempo=_Eff2_tempo3;
							}				
						}
						if ((Flag1 & (1 << PWM2_100_Flag)))
						{	PWM_2_DUTY++;
							PWM_3_DUTY--;
							PWM_1_DUTY--;
							if (_PWM100/4==PWM_2_DUTY) 					
							{
								bitclr(Flag1, PWM2_100_Flag);
							}				
						}
						if (!(Flag1 & (1 << PWM1_100_Flag)) && !(Flag1 & (1 << PWM2_100_Flag)) && !(Flag1 & (1 << PWM3_100_Flag)))
						{	PWM_3_DUTY--;
							PWM_2_DUTY--;
							PWM_1_DUTY--;
							if (0==PWM_2_DUTY) 					
							{
								bitset(Flag1, PWM3_100_Flag);
								Tempo=_Eff2_tempo1;
								Effekt_Mutato++;
							//	goto _kilep;
							}				
						}		
						break;
					case 4:	//B G R
						if ((Flag1 & (1 << PWM3_100_Flag)))
						{	PWM_3_DUTY++;
							if (_PWM100==PWM_3_DUTY)
							{ 
								bitclr(Flag1, PWM3_100_Flag);
								bitset(Flag1, PWM2_100_Flag);
								Tempo=_Eff2_tempo2;
							}
						}
						if ((Flag1 & (1 << PWM2_100_Flag)))
						{	PWM_2_DUTY++;
							PWM_3_DUTY--;
							if (_PWM100/2==PWM_2_DUTY) 					
							{
								bitclr(Flag1, PWM2_100_Flag);
								bitset(Flag1, PWM1_100_Flag);
								Tempo=_Eff2_tempo3;
							}				
						}
						if ((Flag1 & (1 << PWM1_100_Flag)))
						{	PWM_1_DUTY++;
							PWM_2_DUTY--;
							PWM_3_DUTY--;
							if (_PWM100/4==PWM_1_DUTY) 					
							{
								bitclr(Flag1, PWM1_100_Flag);
							}				
						}
						if (!(Flag1 & (1 << PWM1_100_Flag)) && !(Flag1 & (1 << PWM2_100_Flag)) && !(Flag1 & (1 << PWM3_100_Flag)))
						{	PWM_3_DUTY--;
							PWM_2_DUTY--;
							PWM_1_DUTY--;
							if (0==PWM_1_DUTY) 					
							{
								bitset(Flag1, PWM2_100_Flag);
								Tempo=_Eff2_tempo1;
								Effekt_Mutato++;
							//	goto _kilep;
							}				
						}
						break;
					case 5:	//G R B
						if ((Flag1 & (1 << PWM2_100_Flag)))
						{	PWM_2_DUTY++;
							if (_PWM100==PWM_2_DUTY)
							{ 
								bitclr(Flag1, PWM2_100_Flag);
								bitset(Flag1, PWM1_100_Flag);
								Tempo=_Eff2_tempo2;
							}
						}
						if ((Flag1 & (1 << PWM1_100_Flag)))
						{	PWM_1_DUTY++;
							PWM_2_DUTY--;
							if (_PWM100/2==PWM_1_DUTY) 					
							{
								bitclr(Flag1, PWM1_100_Flag);
								bitset(Flag1, PWM3_100_Flag);
								Tempo=_Eff2_tempo3;
							}				
						}
						if ((Flag1 & (1 << PWM3_100_Flag)))
						{	PWM_3_DUTY++;
							PWM_1_DUTY--;
							PWM_2_DUTY--;
							if (_PWM100/4==PWM_3_DUTY) 					
							{
								bitclr(Flag1, PWM3_100_Flag);
							}				
						}
						if (!(Flag1 & (1 << PWM1_100_Flag)) && !(Flag1 & (1 << PWM2_100_Flag)) && !(Flag1 & (1 << PWM3_100_Flag)))
						{	PWM_3_DUTY--;
							PWM_2_DUTY--;
							PWM_1_DUTY--;
							if (0==PWM_3_DUTY) 					
							{
								bitset(Flag1, PWM3_100_Flag);
								Tempo=_Eff2_tempo1;
								Effekt_Mutato++;
							//	goto _kilep;
							}				
						}
						break;
					case 6:	//B R G
						if ((Flag1 & (1 << PWM3_100_Flag)))
						{	PWM_3_DUTY++;
							if (_PWM100==PWM_3_DUTY)
							{ 
								bitclr(Flag1, PWM3_100_Flag);
								bitset(Flag1, PWM1_100_Flag);
								Tempo=_Eff2_tempo2;
							}
						}
						if ((Flag1 & (1 << PWM1_100_Flag)))
						{	PWM_1_DUTY++;
							PWM_3_DUTY--;
							if (_PWM100/2==PWM_1_DUTY) 					
							{
								bitclr(Flag1, PWM1_100_Flag);
								bitset(Flag1, PWM2_100_Flag);
								Tempo=_Eff2_tempo3;
							}				
						}
						if ((Flag1 & (1 << PWM2_100_Flag)))
						{	PWM_2_DUTY++;
							PWM_1_DUTY--;
							PWM_3_DUTY--;
							if (_PWM100/4==PWM_2_DUTY) 					
							{
								bitclr(Flag1, PWM2_100_Flag);
							}				
						}
						if (!(Flag1 & (1 << PWM1_100_Flag)) && !(Flag1 & (1 << PWM2_100_Flag)) && !(Flag1 & (1 << PWM3_100_Flag)))
						{	PWM_3_DUTY--;
							PWM_2_DUTY--;
							PWM_1_DUTY--;
							if (0==PWM_2_DUTY) 					
							{
								bitset(Flag1, PWM1_100_Flag);
								Tempo=_Eff1_tempo; //Els effekt teme
								Effekt_Counter++;
								Effekt_Mutato=1;
							}				
						}
						break;
					default:
						break;
				}
			}
		
//_kilep:
		if (3==Effekt_Counter) Effekt_Counter=0;	// Az utols effekt utn visszavlt az elsre
		Utem_Counter=1;
		}
	}
}

